/* eslint-disable promise/param-names */
/* eslint-disable no-void */
/* eslint-disable object-curly-spacing */
/* eslint-disable indent */
/* eslint-disable max-len */

const chromium = require('@sparticuz/chromium');
require('dotenv').config();

const { addExtra } = require('puppeteer-extra');
const puppeteer = require('puppeteer-core');
const puppeteerExtra = addExtra(puppeteer);

// add stealth plugin and use defaults (all evasion techniques)
const stealthPlugin = require('puppeteer-extra-plugin-stealth');
puppeteerExtra.use(stealthPlugin());

const [, , ...args] = process.argv;

/**
 * Crawl a Instagram page
 * @param {String} link
 * @param {String} user
 * @param {String} password
 * @param {String} sessionPath
 */
async function crawl(link, user, password, sessionPath) {
  const browser = await puppeteerExtra.launch({
    headless: true,
    // We'll have a data dir for underage and another one to overage (LDA)
    userDataDir: './browserData/' + sessionPath,
    args: [
      '--no-sandbox',
      '--disable-setuid-sandbox',
      '--window-size=1920,1080',
      '--lang=pt-BR,pt',
      '--disable-sync',
      '--disable-translate',
      '--no-first-run',
      '--safebrowsing-disable-auto-update',
      '--disable-prompt-on-repost',
      '--disable-popup-blocking',
      '--disable-default-apps',
      '--password-store=basic',
      '--use-mock-keychain',
      '--disable-crash-reporter',
      "--proxy-server='direct://'",
      '--proxy-bypass-list=*',
      '--deterministic-fetch',
    ],
    executablePath: await chromium.executablePath,
    defaultViewport: chromium.defaultViewport,
    ignoreHTTPSErrors: true,
  });

  try {
    const page = await browser.newPage();

    await page.setUserAgent(
      'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.159 Safari/537.36'
    );

    // Increase the default time limit (2 minutes)
    await page.setDefaultNavigationTimeout(120000);

    // Due to a Chromium bug handling with session restore, we need go to another page before
    await page.goto('about:blank');

    // await page.waitForTimeout((Math.random() * 3 + 1) * 1000);

    await page.goto('https://www.instagram.com/accounts/login/', {
      waitUntil: 'networkidle2',
    });

    // Added a random timeout to try avoid a bot behaviour
    // await page.waitForTimeout((Math.random() * 10 + 1) * (Math.random() * 1000));

    const title = await page.title();

    const arrData = {};

    // Check if we need to login
    if (title.indexOf('Login') === 0) {
      arrData.statusLogin = 'logar';

      await page.waitForSelector('input[name="username"]');
      await page.type('input[name="username"]', user);
      await page.type('input[name="password"]', password);
      await page.click('button[type="submit"]');

      await page.waitForNavigation();
    }

    await Promise.race([
      page.goto('about:blank').catch((e) => void e),
      new Promise((x) => setTimeout(x, 5 * 1000)),
    ]);

    await Promise.race([
      page.goto(link, { waitUntil: 'networkidle2' }).catch((e) => void e),
      new Promise((x) => setTimeout(x, 90 * 1000)),
    ]);

    // Random timeout to avoid bot behaviour detection
    await page.waitForTimeout(
      (Math.random() * 10 + 30) * (Math.random() * 1000)
    );

    let innerText = '';
    if (sessionPath !== 'instaUnderage') {
      innerText = await page.evaluate(() => {
        return document.getElementsByTagName('header')[0].innerHTML;
      });
    } else {
      innerText = await page.evaluate(() => {
        return document.getElementsByTagName('body')[0].innerHTML;
      });
    }

    // innerText = await page.content();

    console.log(innerText);

    arrData.content = innerText;

    // const data = await page.content();

    // console.log(arrData);
  } catch (error) {
    console.log(error.message);
    console.log('DGP ERROR @ Instagram Script');
  }

  browser.close();

  process.exit();
}

crawl(args[0], args[1], args[2], args[3]);
