/* eslint-disable promise/param-names */
/* eslint-disable no-void */
/* eslint-disable new-cap */
/* eslint-disable object-curly-spacing */
/* eslint-disable indent */
/* eslint-disable max-len */

const chromium = require('@sparticuz/chromium');
require('dotenv').config();

const { addExtra } = require('puppeteer-extra');
const puppeteer = require('puppeteer-core');
const puppeteerExtra = addExtra(puppeteer);

// add stealth plugin and use defaults (all evasion techniques)
const stealthPlugin = require('puppeteer-extra-plugin-stealth');
puppeteerExtra.use(stealthPlugin());

const [, , ...args] = process.argv;

/**
 * Run test
 *
 * @param {string} link
 * @param {string} additional
 * @param {string} requests
 */
async function test(link) {
  const browser = await puppeteerExtra.launch({
    headless: true,
    args: [
      '--no-sandbox',
      '--disable-setuid-sandbox',
      '--window-size=1920,1080',
      '--lang=pt-BR,pt',
      '--disable-sync',
      '--disable-translate',
      '--no-first-run',
      '--safebrowsing-disable-auto-update',
      '--disable-prompt-on-repost',
      '--disable-popup-blocking',
      '--disable-default-apps',
      '--password-store=basic',
      '--use-mock-keychain',
      '--disable-crash-reporter',
      "--proxy-server='direct://'",
      '--proxy-bypass-list=*',
      '--deterministic-fetch',
    ],
    executablePath: await chromium.executablePath,
    defaultViewport: chromium.defaultViewport,
  });

  const page = await browser.newPage();

  // Increase the default timeout limit (2 minutes)
  await page.setDefaultNavigationTimeout(120000);

  // We'll use promise race to ensure page dont exced our timeout (1.5 minute)
  await Promise.race([
    page.goto(link, { waitUntil: 'networkidle2' }).catch((e) => void e),
    new Promise((x) => setTimeout(x, 90 * 1000)),
  ]);

  const result = await page.evaluate(function () {
    let jsonResult = {};

    if (
      typeof ytInitialData !== 'undefined' &&
      // eslint-disable-next-line no-undef
      ytInitialData.contents.twoColumnWatchNextResults
    ) {
      jsonResult = {};

      const arrayContents =
        // eslint-disable-next-line no-undef
        ytInitialData.contents.twoColumnWatchNextResults.results.results
          .contents;

      for (let index = 0; index < arrayContents.length; index++) {
        const content = arrayContents[index];

        if (content.videoSecondaryInfoRenderer) {
          jsonResult = {
            status: 'success',
            verified:
              typeof content.videoSecondaryInfoRenderer.owner.videoOwnerRenderer
                .badges !== 'undefined',
          };

          break;
        }
      }
    } else if (typeof window.getPageData !== 'undefined') {
      jsonResult = {
        status: 'success',
        // eslint-disable-next-line no-undef
        channelId: getPageData().data.endpoint.browseEndpoint.browseId,
      };
    } else {
      // Added to the cases where channel has age gate
      const base =
        // eslint-disable-next-line no-undef
        ytInitialData.responseContext.serviceTrackingParams[0].params;

      let cid = '';

      for (let index = 0; index < base.length; index++) {
        if (base[index].key === 'browse_id') {
          cid = base[index].value;
        }
      }

      jsonResult = {
        status: 'success',
        channelId: cid,
        agegate: true,
      };
    }

    // getPageData().data.response.header.c4TabbedHeaderRenderer.badges

    return JSON.stringify(jsonResult);
  });

  console.log(result);

  browser.close();

  process.exit();
}

const link = args[0];

test(link);
