<?php

namespace App\Http\Middleware;

use Closure;
use Exception;
use Illuminate\Http\Request;

class ValidateAdminUser
{
  /**
   * Handle an incoming request.
   *
   * @param  \Illuminate\Http\Request  $request
   * @param  \Closure  $next
   * @return mixed
   */
  public function handle(Request $request, Closure $next)
  {
    $return = [];
    $approved = false;

    if ($request->userReq->userLevel === 'SuperAdmin' || $request->userReq->userLevel === 'Admin') {
      $approved = true;
    } else {
      $return = [
        'status' => 'error',
        'message' => 'User unauthorized',
      ];
      $approved = false;
    }

    if (!$approved) {
      return response()->json($return);
    } else {
      return $next($request);
    }
  }
}
