<?php

// phpcs:disable BestIt.DocTags.RequiredPropertyTags.TagOccurrenceMinVar
// phpcs:disable BestIt.TypeHints.PropertyTypeHint.MissingAnyTypeHint

namespace App\Models;

use GeneaLabs\LaravelModelCaching\Traits\Cachable;
use Illuminate\Database\Eloquent\Model;

/**
 * BPOC Website List Class
 *
 * Specifies the fillable atrributes and base configation
 *
 * @author Lucas Buzzo <lucas.buzzo@ab-inbev.com>
 * @package App\Models
 */

class BpocWebsiteList extends Model
{
    use Cachable;

    /**
     * The attributes that are mass assignable.
     */
    protected $fillable = [
        'link',
        'status',
        'zone',
        'country',
        'brand',
        'dgp_scope',
    ];

    /**
     * Define the table name
     */
    protected $table = 'bpoc_website_lists';
}
