<?php

// phpcs:disable BestIt.DocTags.RequiredPropertyTags.TagOccurrenceMinVar
// phpcs:disable BestIt.TypeHints.PropertyTypeHint.MissingAnyTypeHint

namespace App\Models;

use GeneaLabs\LaravelModelCaching\Traits\Cachable;
use Illuminate\Database\Eloquent\Model;

/**
 * Cookie Compliance Report
 *
 * Specifies the fillable atrributes and base configation
 *
 * @author Lucas Buzzo <lucas.buzzo@ab-inbev.com>
 * @package App\Models
 */

class CookieComplianceReport extends Model
{
    use Cachable;

    /**
     * The attributes that are mass assignable.
     */
    protected $fillable = [
        'link',
        'zone',
        'country',
        'dgp',
        'cookie_banner_implemented',
        'banner_domain',
        'banner_same_domain',
        'cookie_compliance',
        'non_strictly',
        'domain_compliance',
        'executed_at',
        'site_status',
        'scriptStatus',
    ];

    /**
     * Define the table name
     */
    protected $table = 'cookie_compliance_reports';
}
