<?php

// phpcs:disable BestIt.DocTags.RequiredPropertyTags.TagOccurrenceMinVar
// phpcs:disable BestIt.TypeHints.PropertyTypeHint.MissingAnyTypeHint

namespace App\Models;

use GeneaLabs\LaravelModelCaching\Traits\Cachable;
use Illuminate\Database\Eloquent\Model;

/**
 * Crawls Class
 *
 * Specifies the fillable atrributes and base configation
 *
 * @author Lucas Buzzo <lucas.buzzo@ab-inbev.com>
 * @package App\Models
 */
class Crawls extends Model
{
    use Cachable;

    /**
     * The attributes that are mass assignable.
     */
    protected $fillable = [
        'link',
        'data_type',
        'content',
        'executed_at',
        'official',
        'age',
        'created_at',
    ];

    /**
     * Define the table name
     */
    protected $table = 'crawls';

    /**
     * We need to specify that we dont have the default timestamps columns
     */
    public $timestamps = false;
}
