<?php

namespace App\Models;

// phpcs:disable BestIt.DocTags.RequiredPropertyTags.TagOccurrenceMinVar
// phpcs:disable BestIt.TypeHints.PropertyTypeHint.MissingAnyTypeHint

use GeneaLabs\LaravelModelCaching\Traits\Cachable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

/**
 * User Class
 *
 * Specify the fillable atrributes and base configation
 *
 * @author Lucas Buzzo <lucas.buzzo@ab-inbev.com>
 * @package App\Models
 */

class User extends Authenticatable
{
    use Cachable;
    use HasFactory;
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     */
    protected $fillable = [
        'name',
        'email',
        'zone_id',
    ];

    /**
     * Define the table name
     */
    protected $table = 'users';

    /**
     * Return the zone from user
     *
     * @return belongsTo
     */
    public function zone(): BelongsTo
    {
        return $this->BelongsTo(Zone::class, 'zone_id');
    }
}
