<?php

namespace Database\Factories;

use App\Models\Assessment;
use App\Models\Criteria;
use App\Models\CriteriaCategory;
use Illuminate\Database\Eloquent\Factories\Factory;
use Illuminate\Http\UploadedFile;
use Illuminate\Support\Str;

class CriteriaFactory extends Factory
{
    /**
     * The name of the factory's corresponding model.
     *
     * @var string
     */
    protected $model = Criteria::class;

    /**
     * Define the model's default state.
     *
     * @return array
     */
    public function definition()
    {
        $assessment = Assessment::factory()->create();

        $criteriaCategory = CriteriaCategory::factory()->create();

        $name = $this->faker->name;

        $slug = Str::slug($name, '-');

        return [
            'assessment_id' => $assessment->id,
            'criteria_category_id' => $criteriaCategory->id,
            'job_function' => $this->faker->sentence(1),
            'manual' => UploadedFile::fake()->create('test.pdf', 100, 'application/pdf'),
            'min_assessment_aggregate' => rand(0, 100),
            'name' => $name,
            'position' => rand(0, 10),
            'slug' => $slug
        ];
    }
}
