<?php

namespace Database\Factories;

use App\Models\Criteria;
use App\Models\LinkCriteria;
use App\Models\Links;
use App\Models\ResponseAssessment;
use Illuminate\Database\Eloquent\Factories\Factory;

class LinkCriteriaFactory extends Factory
{
    /**
     * The name of the factory's corresponding model.
     *
     * @var string
     */
    protected $model = LinkCriteria::class;

    /**
     * Define the model's default state.
     *
     * @return array
     */
    public function definition()
    {
        $criteria = Criteria::factory()->create();
        $assessment = $criteria->assessment;

        $trueResponse = new ResponseAssessment();
        $trueResponse->assessment_id = $assessment->id;
        $trueResponse->value = 'true';
        $trueResponse->description = 'true';
        $trueResponse->save();

        $falseResponse = new ResponseAssessment();
        $falseResponse->assessment_id = $assessment->id;
        $falseResponse->value = 'false';
        $falseResponse->description = 'false';
        $falseResponse->save();

        $link = Links::factory()->create();

        $response = (rand(0, 1) === 1) ? $trueResponse : $falseResponse;

        return [
            'criteria_id' => $criteria->id,
            'link_id' => $link->id,
            'response_id' => $response->id,
            'executed_at' => date('Y-m-d H:i:s')
        ];
    }
}
