<?php

namespace Database\Factories;

use App\Models\Assessment;
use App\Models\ResponseAssessment;
use Illuminate\Database\Eloquent\Factories\Factory;

class ResponseAssessmentFactory extends Factory
{
    /**
     * The name of the factory's corresponding model.
     *
     * @var string
     */
    protected $model = ResponseAssessment::class;

    /**
     * Define the model's default state.
     *
     * @return array
     */
    public function definition()
    {
        $assessment = new Assessment();
        $assessment->name = $this->faker->sentence(1);
        $assessment->input_type = 'select';
        $assessment->save();

        return [
            'assessment_id' => $assessment->id,
            'description' => $this->faker->sentence(2),
            'value' => $this->faker->sentence(1),
        ];
    }
}
