<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateLinksCriteriaTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::connection('pgsql2')->create('links_criteria', function (Blueprint $table) {
            $table->id();
            $table->integer('criteria_id')->index('linkscriteria_criteria_index');
            $table->integer('link_id')->index('linkscriteria_link_index');
            $table->timestamp('executed_at')->nullable()->index('linkscriteria_execution_index');
            $table->string('response')->nullable();
            $table->string('details')->nullable();
            $table->boolean('official')->nullable()->default(false)->index('linkscriteria_official_index');
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->dropIfExists('links_criteria');
    }
}
