<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateLinksTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::connection('pgsql2')->create('links', function (Blueprint $table) {
            $table->id();
            $table->string('link', 1000)->index();
            $table->text('additional_crawler')->nullable();
            $table->bigInteger('semrush_project_id')->nullable();
            $table->integer('brand_id')->index('links_brand_index');
            $table->integer('channel_id')->index('links_channel_index');
            $table->integer('country_id')->index('links_country_index');
            $table->integer('owner_id')->nullable()->index('links_owner_index');
            $table->string('http_status', 100)->index('links_status_index');
            $table->string('business_area', 100)->index('links_business_index');
            $table->string('enviroment', 100)->index();
            $table->boolean('consider')->default(false)->index();
            $table->string('scope', 200)->index();
            $table->boolean('in_ga')->default(false);
            $table->boolean('in_acquia')->default(false);
            $table->boolean('in_bp')->default(false);
            $table->boolean('in_cdp')->default(false);
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->dropIfExists('links');
    }
}
