<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddForeignKeysToCountriesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::connection('pgsql2')->table('countries', function (Blueprint $table) {
            $table->foreign(['zone_id'], 'countries_zone_id_fkey')->references(['id'])->on('zones');
            $table->foreign(['locale_id'], 'countries_locale_id_fkey')->references(['id'])->on('locales');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->table('countries', function (Blueprint $table) {
            $table->dropForeign('countries_zone_id_fkey');
            $table->dropForeign('countries_locale_id_fkey');
        });
    }
}
