<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddForeignKeysToLinksCriteriaTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::connection('pgsql2')->table('links_criteria', function (Blueprint $table) {
            $table->foreign(['criteria_id'], 'links_criteria_criteria_id_fkey')->references(['id'])->on('criteria');
            $table->foreign(['link_id'], 'links_criteria_link_id_fkey')->references(['id'])->on('links');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->table('links_criteria', function (Blueprint $table) {
            $table->dropForeign('links_criteria_criteria_id_fkey');
            $table->dropForeign('links_criteria_link_id_fkey');
        });
    }
}
