<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddForeignKeysToTestsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::connection('pgsql2')->table('tests', function (Blueprint $table) {
            $table->foreign(['link_id'], 'tests_link_id_fkey')->references(['id'])->on('links');
            $table->foreign(['criteria_id'], 'tests_criteria_id_fkey')->references(['id'])->on('criteria');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->table('tests', function (Blueprint $table) {
            $table->dropForeign('tests_link_id_fkey');
            $table->dropForeign('tests_criteria_id_fkey');
        });
    }
}
