<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddForeignKeysToUserPermissionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::connection('pgsql2')->table('user_permissions', function (Blueprint $table) {
            $table->foreign(['user_id'], 'user_permissions_user_id_fkey')->references(['id'])->on('users');
            $table->foreign(['permission_id'], 'user_permissions_permission_id_fkey')->references(['id'])->on('permissions');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->table('user_permissions', function (Blueprint $table) {
            $table->dropForeign('user_permissions_user_id_fkey');
            $table->dropForeign('user_permissions_permission_id_fkey');
        });
    }
}
