<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('manual_validation', function (Blueprint $table) {
            $table->id();
            $table->integer('link_id');
            $table->timestamp('exec_date');
            $table->boolean('validated')->default(false);
            $table->timestamps();
            $table->softDeletes();
            
            $table->foreign('link_id')->references(['id'])->on('links');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('manual_validation');
    }
};
