<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('lighthouse_data', function (Blueprint $table) {
            $table->id();

            $table->integer('link_id')->index('lighthousedata_link_id');
            $table->text('link', 200)->index('lighthousedata_link');
            $table->text('zone', 50)->index('lighthousedata_zone');
            $table->text('country', 50)->index('lighthousedata_country');
            $table->timestamp('executed_at')->index('lighthousedata_execution_index');

            $table->string('first_contentful_paint', 10);
            $table->string('largest_contentful_paint', 10);
            $table->string('total_blocking_time', 10);
            $table->string('speed_index', 10);
            $table->string('time_to_interactive', 10);
            $table->string('cumulative_layout_shift', 10);
            $table->integer('lighthouse_avg');
            $table->integer('lighthouse_last');

            $table->timestamp('created_at')->useCurrent();

            $table->foreign('link_id')->references(['id'])->on('links');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::connection('pgsql2')->dropIfExists('lighthouse_data');
    }
};
