<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('crawls', function (Blueprint $table) {
            $table->id();

            $table->text('link', 200)->index('crawls_link');
            $table->text('data_type', 50)->index('crawls_data_type');
            $table->longText('content');
            $table->timestamp('executed_at')->index('crawls_execution_index');
            $table->boolean('official')->default(true);
            $table->string('age', 10)->nullable();

            $table->timestamp('created_at')->useCurrent();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('crawls');
    }
};
