<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Support\Facades\DB;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        DB::statement('DROP MATERIALIZED VIEW IF exists reportDgp');
        DB::statement('CREATE MATERIALIZED VIEW reportdgp AS SELECT CASE WHEN(alcoholic IS TRUE) THEN( SELECT CASE WHEN( channel = \'Site\' AND "age_gate" :: boolean IS TRUE AND "coi" :: boolean IS TRUE AND "rdm" :: boolean IS TRUE) THEN TRUE WHEN( channel <> \'Site\' AND "age_gate" :: boolean IS TRUE AND "coi" :: boolean IS TRUE AND "rdm" :: boolean IS TRUE AND "fan" :: boolean IS TRUE AND "ugc" :: boolean IS TRUE ) THEN TRUE ELSE FALSE END ) ELSE ( SELECT CASE WHEN ("coi" :: boolean IS TRUE) THEN TRUE ELSE FALSE END ) END AS "iard", ( CASE WHEN channel = \'Site\' THEN ( ( SELECT CASE WHEN ( ( lower("risk_rate") = \'low\' OR lower("risk_rate") = \'medium\' ) AND ( lower("vulnerability_level") = \'low\' OR lower("vulnerability_level") = \'medium\' ) AND ( ( lower("pia_completion") = \'completed\' ) OR ( lower("pia_completion") = \'true\' ) ) ) THEN 75 ELSE 0 END CASE ):: integer + ( SELECT CASE WHEN ( "cookie_banner_implemented" = \'true\' ) THEN 20 ELSE 0 END CASE ):: integer + ( SELECT CASE WHEN ( "cookie_dropping_compliance" = \'true\' ) THEN 5 ELSE 0 END CASE ):: integer ):: integer ELSE NULL END ):: integer AS "privacy_security", CASE WHEN channel = \'Site\' THEN ( SELECT CASE WHEN ( "semrush" >= 75 AND "lighthouse_avg" >= 50 ) THEN 100 WHEN ( "semrush" >= 75 OR "lighthouse_avg" >= 50 ) THEN 50 ELSE 0 END CASE ) ELSE NULL END AS "property_excellence", CASE WHEN channel = \'Site\' THEN ( SELECT CASE WHEN ( "cdp_implementation" = \'true\' AND "ga_implementation" = \'true\' AND "ga_access" = \'true\' AND "ga_taxonomy" = \'true\' ) THEN 100 WHEN ( "cdp_implementation" = \'false\' AND "ga_implementation" = \'true\' AND "ga_access" = \'true\' AND "ga_taxonomy" = \'true\' ) THEN 50 WHEN ( "cdp_implementation" = \'true\' AND ( "ga_implementation" = \'false\' OR "ga_access" = \'false\' OR "ga_taxonomy" = \'false\' ) ) THEN 50 ELSE 0 END CASE ) ELSE NULL END AS "website_data", CASE WHEN channel = \'Site\' THEN ( SELECT CASE WHEN ( "cookie_banner_implemented" = \'true\' AND "cookie_dropping_compliance" = \'true\' ) THEN TRUE ELSE FALSE END CASE ) ELSE NULL END AS "cookie_compliance", * FROM ( SELECT DISTINCT z.name AS ZONE, c.name AS country, b.name AS brand, l.alcoholic AS alcoholic, l.link AS LINK, l."scope" AS department, ch.name AS channel, lc.executed_at AS executed_at, lc.official AS official, CASE WHEN l.alcoholic = TRUE THEN ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'agegate\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) ELSE \'NA\' END AS age_gate, ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'coi\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS coi, CASE WHEN l.alcoholic = TRUE THEN ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'fan\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) ELSE \'NA\' END AS fan, CASE WHEN l.alcoholic = TRUE THEN ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'rdm\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) ELSE \'NA\' END AS rdm, CASE WHEN l.alcoholic = TRUE THEN ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'ugc\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) ELSE \'NA\' END AS ugc, ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'risk-rate\' ) AND ( to_char(lc.executed_at, \'YYYY-MM\') = to_char(lci.executed_at, \'YYYY-MM\') ) AND lci.link_id = l.id ORDER BY lci.executed_at DESC LIMIT 1 ) AS risk_rate, ( SELECT lci.response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'vulnerability-level\' ) AND ( to_char(lc.executed_at, \'YYYY-MM\') = to_char(lci.executed_at, \'YYYY-MM\') ) AND lci.link_id = l.id ORDER BY lci.executed_at DESC LIMIT 1 ) AS vulnerability_level, ( SELECT (lci.response :: varchar) FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'pia-completion\' ) AND ( to_char(lc.executed_at, \'YYYY-MM\') = to_char(lci.executed_at, \'YYYY-MM\') ) AND lci.link_id = l.id ORDER BY lci.executed_at DESC LIMIT 1 ) AS pia_completion, ( SELECT (lci.response):: boolean FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'cdp-implementation\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS cdp_implementation, ( SELECT (lci.response):: boolean FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'ga-implementation\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS ga_implementation, ( SELECT (lci.response):: boolean FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'ga-access\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS ga_access, ( SELECT (lci.response):: boolean FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'ga-taxonomy\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS ga_taxonomy, ( SELECT (lci.response):: INTEGER FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'http-response\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS http_response, ( SELECT COALESCE(lci.response :: INTEGER, 0) AS response FROM links_criteria lci WHERE lci.criteria_id = ( SELECT id FROM criteria c3 WHERE c3.slug = \'semrush\' ) AND (lc.executed_at = lci.executed_at) AND lci.link_id = l.id ORDER BY lc.id DESC LIMIT 1 ) AS semrush, ( SELECT first_contentful_paint FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS first_contentful_paint, ( SELECT largest_contentful_paint FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS largest_contentful_paint, ( SELECT total_blocking_time FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS total_blocking_time, ( SELECT speed_index FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS speed_index, ( SELECT time_to_interactive FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS time_to_interactive, ( SELECT cumulative_layout_shift FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS cumulative_layout_shift, ( SELECT ( case when c."name" = \'Russia\' or c."name" = \'Ukraine\' then null else ( SELECT lighthouse_avg FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) end ) ) AS lighthouse_avg, ( SELECT lighthouse_last FROM lighthouse_data ld WHERE ld.executed_at <= lc.executed_at AND ld.link_id = l.id ORDER BY ld.executed_at DESC LIMIT 1 ) AS lighthouse_last, ( SELECT ( case when cookie_banner_implemented then true when "scriptStatus" = \'Published\' then true else false end ) FROM cookie_compliance_reports ccr WHERE ccr.executed_at <= lc.executed_at AND ccr.link ilike l.link ORDER BY ccr.executed_at DESC LIMIT 1 ) AS cookie_banner_implemented, ( SELECT cookie_compliance FROM cookie_compliance_reports ccr WHERE ccr.executed_at <= lc.executed_at AND ccr.link ilike l.link ORDER BY ccr.executed_at DESC LIMIT 1 ) AS cookie_dropping_compliance FROM links_criteria lc JOIN links l ON l.id = lc.link_id JOIN countries c ON c.id = l.country_id JOIN zones z ON z.id = c.zone_id JOIN criteria c2 ON c2.id = lc.criteria_id JOIN brands b ON b.id = l.brand_id JOIN channels ch ON ch.id = l.channel_id WHERE lc.criteria_id = ( SELECT id FROM criteria c4 WHERE slug = \'http-response\' ) and lc.use_on_report = true ORDER BY z.name, c.name, l.link ) AS dgpinner ( "zone", "country", "brand", "alcoholic", "link", "department", "channel", "executed_at", "official", "age_gate", "coi", "fan", "rdm", "ugc", "risk_rate", "vulnerability_level", "pia_completion", "cdp_implementation", "ga_implementation", "ga_access", "ga_taxonomy", "http_response", "semrush", "first_contentful_paint", "largest_contentful_paint", "total_blocking_time", "speed_index", "time_to_interactive", "cumulative_layout_shift", "lighthouse_avg", "lighthouse_last", "cookie_banner_implemented", "cookie_dropping_compliance")');

        DB::statement('CREATE INDEX ON reportdgp ((lower(zone)));');
        DB::statement('CREATE INDEX ON reportdgp ((lower(country)));');
        DB::statement('CREATE INDEX ON reportdgp ((lower(brand)));');
        DB::statement('CREATE INDEX ON reportdgp ((lower(link)));');
        DB::statement('CREATE INDEX ON reportdgp ((lower(department)));');
        DB::statement('CREATE INDEX ON reportdgp ((lower(channel)));');
        DB::statement('CREATE INDEX ON reportdgp ((executed_at));');
        DB::statement('CREATE INDEX ON reportdgp ((official));');
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        DB::statement('DROP MATERIALIZED VIEW IF exists reportdgp');
    }
};
