module.exports = {
  base: '/php/docs/',
  port: 3001,
  dest: '/var/www/public/docs/',
  locales: {
    '/': {
      lang: 'en-US',
      title: 'ABI DGP - Docs',
      description: 'The documentation for DGP by AbInbev',
    },
  },
  plugins: [
    [
      'autometa',
      {
        image: false,
        site: {
          name: '- Docs',
        },
        canonical_base: 'https://dgp.ab-inbev.com/php/docs/',
      },
    ],
  ],
  // serviceWorker: true,
  themeConfig: {
    /*
    algolia: {
      apiKey: '8c789b5d0ee680a4a383673877be347d',
      indexName: 'vue-community'
    },
    */
    logo: '/logo_pin.png',
    docsDir: 'docs',
    editLinks: false,
    sidebarDepth: 3,
    locales: {
      '/': {
        label: 'English',
        selectText: 'Languages',
        nav: [
          {
            text: 'Docs',
            link: '/docs/',
          },
        ],
        sidebar: [
          '/',
          {
            title: 'Getting Started',
            collapsable: false,
            children: [
              '/docs/getting-started/introduction.md',
              '/docs/getting-started/system-requirements.md',
              '/docs/getting-started/installation.md',
              '/docs/getting-started/crawling-process.md',
            ],
          },
          {
            title: 'Preparation',
            collapsable: false,
            children: [
              '/docs/preparation/asset-management.md',
              '/docs/preparation/agegate-bypass.md',
              '/docs/preparation/keywords.md',
            ],
          },
          {
            title: 'Audit',
            collapsable: false,
            children: [
              '/docs/audit/iard.md',
              '/docs/audit/cookie.md',
              '/docs/audit/google-lighthouse.md',
            ],
          },
          {
            title: 'Maintenance and Validation',
            collapsable: false,
            children: [
              '/docs/maintenance-validation/manual-validation.md',
              '/docs/maintenance-validation/improvements.md',
            ],
          },
        ],
      },
    },
  },
  head: [
    [
      'link',
      {
        rel: 'icon',
        href: '/favicon.svg',
      },
    ],
    [
      'script',
      {},
      `
        (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
        new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
        j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
        'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
        })(window,document,'script','dataLayer','GTM-TG53DP5')
    `,
    ],
  ],
};
