# Improvements

Probably, during the [manual validation](https://dgp.ab-inbev.com/php/docs/docs/maintenance-validation/manual-validation.html) you'll notice some cases that the robot has failed. No matter if the case of the failure is some new keyword that you'll need to add in the database or if the reason for failure is something that has changed in the process.

## New keyword identified

In the AbInbev scenario, where we're a global company with decentralized decisions and giving the freedom to the brands to decide which words they will use, we saw some different cases over the year. One case that we can quote is the age-gate.

Some brands decide to put the whole message to request the user message, like [https://www.stellaartois.ca/en](https://www.stellaartois.ca/en):

<img :src="$withBase('/images/agegate-stella-ca.png#center')" alt="Agegate Stella Canada">

and you'll have cases that the brand decided to use this freedom to create something quite different, like [https://mercihoreca.be/nl/](https://mercihoreca.be/nl/)

<img :src="$withBase('/images/agegate-leffe-nl.png#center')" alt="Agegate Leffe NL">

Both cases have a valid age-gate, and we need to give the visibility to the brand that everything is all right here - that is one example of a case that could only be discovered after performing the manual validation.

## Robot failure

In case of being identified a failure in the robot, you'll need to do a troubleshooting/debugging process to discover the root of the failure and how to solve it.

One example of the problem that we're in the past is Facebook/Instagram blocking the user due to the number of requests/access to the profiles, we took the needed actions and so far is working.

The actions that we took:

- We're storing the authenticated data (cookies, storage, cache, etc) to only perform a new login if needed (the robot is capable to identify when is needed to perform a login, and do the login);
- We've added a random delay between the requests;
- We've added multiple configurations to avoid Meta bot detection, based on [this repository](https://github.com/berstend/puppeteer-extra/tree/master/packages).

However, it needed to be a constant monitoring and improvement process to ensure that everything is working.
