# Keywords

For IARD criteria (agegate, COI, FAN, RDM, UGC) keyword mapping is one of the mandatory steps, with the keywords will be defined if one asset is approved or not in one specific criterion.

We've made public the list of keywords that we used in our last audit, updated on 2022-01-31: [here](https://dgp.ab-inbev.com/php/20230131-keywords-dump.sql.zip) containing more than 1.200 keywords that we've mapped over the years in our assets.

## Creating new keywords

There are two possible ways to manage the keywords: directly in the database or using the ticket interface.

### Database

All the keywords that will be searched in the output of our crawlers are stored in the table **keywords**, the structure of the table is below:

<img :src="$withBase('/images/keyword-table-structure.png#center')" alt="Keyword table structure">

The details about each column are below:

| Column      | Description                                                           |
| ----------- | --------------------------------------------------------------------- |
| id          | Autoincrement. The identifier of the keyword entry                    |
| keyword     | The text to be searched                                               |
| criteria_id | Define to which criteria this keyword belongs to                      |
| locale_id   | The locale that this keywords belongs to                              |
| group\*     | Used in cases that more than one type of keyword need to be satisfied |

\* One example of the usage of the "group" column is the COI criteria. For a website to be approved in COI, need to have:

1. Some text saying that the website is official;
2. Privacy Policy

### Interface

For the AbInbev scenario, we've decided to allow any user to request a new keyword to be registered - creating a ticket directly in the platform. However, will be needed the approval of an admin user.

<img :src="$withBase('/images/keyword-page.png#center')" alt="Keyword page">

On that page, any user can list, export or request updates on the keywords.

After the user clicks on the "Create new keyword" button, the modal to open a ticket will show up:

<img :src="$withBase('/images/ticket-keyword.png#center')" alt="Opening keyword ticket">

Once the user finishes the ticket opening, the admin can see and approve/reprove:

<img :src="$withBase('/images/ticket-admin-view.png#center')" alt="Opening keyword ticket">
