import { createStore } from 'vuex';

export default createStore({
  strict: true, // process.env.NODE_ENV !== 'production',
  state: {
    isSidebarMinimized: false,
    userLevel: '',
    userId: null,
    sessionId: null,
    lastRowWebProp: null,
    updatedTicket: {},
    lastUpdatedValidationRow: {},
  },
  getters: {
    getUserLevel: (state) => {
      return state.userLevel;
    },
    getUserId: (state) => {
      return state.userId;
    },
    getSessionId: (state) => {
      return state.sessionId;
    },
    getUpdatedTicket: (state) => {
      return state.updatedTicket;
    },
    getLastRowWebProp: (state) => {
      return state.lastRowWebProp;
    },
    GET_LAST_UPDATED_VALIDATION_ROW: (state) => {
      return state.lastUpdatedValidationRow;
    },
  },
  mutations: {
    updateSidebarCollapsedState(state, isSidebarMinimized) {
      state.isSidebarMinimized = isSidebarMinimized;
    },
    updateUserLevel(state, userLevel) {
      state.userLevel = userLevel;
    },
    updateUserId(state, userId) {
      state.userId = userId;
    },
    updateSessionId(state, sessionId) {
      state.sessionId = sessionId;
    },
    handleLastUpdatedTicket(state, ticketId) {
      state.updatedTicket = ticketId;
    },
    handleLastRowWebProp(state, link) {
      state.lastRowWebProp = link;
    },
    SET_LAST_UPDATED_VALIDATION_ROW(state, rowObj) {
      state.lastUpdatedValidationRow = rowObj;
    },
  },
});
